<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__logging__func" kind="group">
    <compoundname>group_logging_func</compoundname>
    <title>Logging functions</title>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__logging__func_1ga58651ec3d45e88bcf22ad57a7122502b" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_log_init</definition>
        <argsstring>(CY_LOG_LEVEL_T level, log_output platform_output, platform_get_time platform_time)</argsstring>
        <name>cy_log_init</name>
        <param>
          <type><ref kindref="member" refid="group__group__logging__enums_1ga51a7f6067daa4d3c75fd5ee654737fca">CY_LOG_LEVEL_T</ref></type>
          <declname>level</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__logging__structures_1ga0d4aaefe596ccbe75b2f906d8f5938f5">log_output</ref></type>
          <declname>platform_output</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__logging__structures_1gae2c1f8addf44c6d8c3eae0ba99182f73">platform_get_time</ref></type>
          <declname>platform_time</declname>
        </param>
        <briefdescription>
<para>Initialize the logging subsystem. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">level</parametername>
</parameternamelist>
<parameterdescription>
<para>: The initial logging level to use for all facilities. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">platform_output</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to the function invoked by the library to output the log messages. If this argument is passed as NULL, the library prints the log output on the standard output stream (stdio). </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">platform_time</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to the function invoked by the library to get the time. If this argument is passed as NULL, the library calls <ulink url="https://cypresssemiconductorco.github.io/abstraction-rtos/html/group__group__abstraction__rtos__time.html">cy_rtos_get_time</ulink> function to get the time required for logging.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>cy_rslt_t </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" line="180" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__logging__func_1ga9df08670a49c78224aa1826fd0be54fb" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_log_shutdown</definition>
        <argsstring>(void)</argsstring>
        <name>cy_log_shutdown</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>Shutdown the logging subsystem. </para>        </briefdescription>
        <detaileddescription>
<para><simplesect kind="return"><para>cy_rslt_t </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" line="186" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__logging__func_1ga43ee69c5e9ac44d917a27a1e49bd7098" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_log_set_platform_output</definition>
        <argsstring>(log_output platform_output)</argsstring>
        <name>cy_log_set_platform_output</name>
        <param>
          <type><ref kindref="member" refid="group__group__logging__structures_1ga0d4aaefe596ccbe75b2f906d8f5938f5">log_output</ref></type>
          <declname>platform_output</declname>
        </param>
        <briefdescription>
<para>Set the platform output routine for log messages. </para>        </briefdescription>
        <detaileddescription>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;If platform_output is NULL, log messages will be discarded.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">platform_output</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to the platform output routine for log messages.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>cy_rslt_t </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" line="196" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__logging__func_1ga28fef2ede13ef8109e6b27805ac8f749" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_log_set_platform_time</definition>
        <argsstring>(platform_get_time platform_time)</argsstring>
        <name>cy_log_set_platform_time</name>
        <param>
          <type><ref kindref="member" refid="group__group__logging__structures_1gae2c1f8addf44c6d8c3eae0ba99182f73">platform_get_time</ref></type>
          <declname>platform_time</declname>
        </param>
        <briefdescription>
<para>Set the platform routine for getting time stamps for log messages. </para>        </briefdescription>
        <detaileddescription>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;If platform_time is NULL, cy_time_get_time() is used for time stamps.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">platform_time</parametername>
</parameternamelist>
<parameterdescription>
<para>: Pointer to a platform time routine for log message time stamps.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>cy_rslt_t </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" line="206" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__logging__func_1gaa063d8ccda8314098cfca1f983197a52" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_log_set_facility_level</definition>
        <argsstring>(CY_LOG_FACILITY_T facility, CY_LOG_LEVEL_T level)</argsstring>
        <name>cy_log_set_facility_level</name>
        <param>
          <type><ref kindref="member" refid="group__group__logging__enums_1ga77dcf80196a559e0918a18c45b326f3a">CY_LOG_FACILITY_T</ref></type>
          <declname>facility</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__logging__enums_1ga51a7f6067daa4d3c75fd5ee654737fca">CY_LOG_LEVEL_T</ref></type>
          <declname>level</declname>
        </param>
        <briefdescription>
<para>Set the logging level for a facility. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">facility</parametername>
</parameternamelist>
<parameterdescription>
<para>: The facility for which to set the log level. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">level</parametername>
</parameternamelist>
<parameterdescription>
<para>: The new log level to use.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>cy_rslt_t </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" line="215" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__logging__func_1ga35ea5f0b250f8e2b7fea35f031b6ee06" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_log_set_all_levels</definition>
        <argsstring>(CY_LOG_LEVEL_T level)</argsstring>
        <name>cy_log_set_all_levels</name>
        <param>
          <type><ref kindref="member" refid="group__group__logging__enums_1ga51a7f6067daa4d3c75fd5ee654737fca">CY_LOG_LEVEL_T</ref></type>
          <declname>level</declname>
        </param>
        <briefdescription>
<para>Set the logging level for all facilities. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">level</parametername>
</parameternamelist>
<parameterdescription>
<para>: The new log level to use.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>cy_rslt_t </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" line="223" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__logging__func_1ga6b4f9cc32c62adaac3dd357b869c59a1" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__logging__enums_1ga51a7f6067daa4d3c75fd5ee654737fca">CY_LOG_LEVEL_T</ref></type>
        <definition>CY_LOG_LEVEL_T cy_log_get_facility_level</definition>
        <argsstring>(CY_LOG_FACILITY_T facility)</argsstring>
        <name>cy_log_get_facility_level</name>
        <param>
          <type><ref kindref="member" refid="group__group__logging__enums_1ga77dcf80196a559e0918a18c45b326f3a">CY_LOG_FACILITY_T</ref></type>
          <declname>facility</declname>
        </param>
        <briefdescription>
<para>Get the logging level for a facility. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">facility</parametername>
</parameternamelist>
<parameterdescription>
<para>: The facility for which to return the log level.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The current log level. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" line="231" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__logging__func_1gac30db641e4001edf1692b13e75cb0659" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_log_msg</definition>
        <argsstring>(CY_LOG_FACILITY_T facility, CY_LOG_LEVEL_T level, const char *fmt,...)</argsstring>
        <name>cy_log_msg</name>
        <param>
          <type><ref kindref="member" refid="group__group__logging__enums_1ga77dcf80196a559e0918a18c45b326f3a">CY_LOG_FACILITY_T</ref></type>
          <declname>facility</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__logging__enums_1ga51a7f6067daa4d3c75fd5ee654737fca">CY_LOG_LEVEL_T</ref></type>
          <declname>level</declname>
        </param>
        <param>
          <type>const char *</type>
          <declname>fmt</declname>
        </param>
        <param>
          <type>...</type>
        </param>
        <briefdescription>
<para>Write a log message. </para>        </briefdescription>
        <detaileddescription>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The format arguments are the same as for printf.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">facility</parametername>
</parameternamelist>
<parameterdescription>
<para>: The facility for the log message. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">level</parametername>
</parameternamelist>
<parameterdescription>
<para>: Log level of the message. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">fmt</parametername>
</parameternamelist>
<parameterdescription>
<para>: Format control string followed by any optional arguments.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>cy_rslt_t </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" line="243" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__logging__func_1ga7a2cc061bf37ae6a1538b80b38bb88ca" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_log_printf</definition>
        <argsstring>(const char *fmt,...)</argsstring>
        <name>cy_log_printf</name>
        <param>
          <type>const char *</type>
          <declname>fmt</declname>
        </param>
        <param>
          <type>...</type>
        </param>
        <briefdescription>
<para>Write a log message bypassing the log level check. </para>        </briefdescription>
        <detaileddescription>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The format arguments are the same as for printf.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">fmt</parametername>
</parameternamelist>
<parameterdescription>
<para>: Format control string followed by any optional arguments.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>cy_rslt_t </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" line="253" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__logging__func_1gab9d1cb336ea7bb6b51b37d7d06b5f891" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t cy_log_vprintf</definition>
        <argsstring>(const char *fmt, va_list varg)</argsstring>
        <name>cy_log_vprintf</name>
        <param>
          <type>const char *</type>
          <declname>fmt</declname>
        </param>
        <param>
          <type>va_list</type>
          <declname>varg</declname>
        </param>
        <briefdescription>
<para>Write a log message bypassing the log level check using va_list. </para>        </briefdescription>
        <detaileddescription>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The format arguments are the same as for vprintf.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">fmt</parametername>
</parameternamelist>
<parameterdescription>
<para>: Format control string. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">varg</parametername>
</parameternamelist>
<parameterdescription>
<para>: va_list of arguments.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>cy_rslt_t </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/mw-utilities/cy_log/cy_log.h" line="264" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>A logging subsystem that allows run time control for the logging level. </para>    </briefdescription>
    <detaileddescription>
    </detaileddescription>
  </compounddef>
</doxygen>